// DefaultHandler.h: interface for the DefaultHandler class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DEFAULTHANDLER_H__517D91C0_0BCF_474D_A77C_10EE27231233__INCLUDED_)
#define AFX_DEFAULTHANDLER_H__517D91C0_0BCF_474D_A77C_10EE27231233__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CDefaultHandler :
	public ISAXContentHandler,
	//public ISAXDTDHandler,
	//public ISAXEntityResolver,
	public ISAXErrorHandler
{
public:
    CDefaultHandler();
    virtual ~CDefaultHandler();

	/*
	 * From ISAXContentHandler
	 */

public:
    virtual HRESULT STDMETHODCALLTYPE putDocumentLocator(
        /* [in] */ ISAXLocator __RPC_FAR *pLocator);

    virtual HRESULT STDMETHODCALLTYPE startDocument(void);

    virtual HRESULT STDMETHODCALLTYPE endDocument(void);

    virtual HRESULT STDMETHODCALLTYPE startPrefixMapping(
        /* [in] */ wchar_t __RPC_FAR *pwchPrefix,
        /* [in] */ int cchPrefix,
        /* [in] */ wchar_t __RPC_FAR *pwchUri,
        /* [in] */ int cchUri);

    virtual HRESULT STDMETHODCALLTYPE endPrefixMapping(
        /* [in] */ wchar_t __RPC_FAR *pwchPrefix,
        /* [in] */ int cchPrefix);

    virtual HRESULT STDMETHODCALLTYPE startElement(
        /* [in] */ wchar_t __RPC_FAR *pwchNamespaceUri,
        /* [in] */ int cchNamespaceUri,
        /* [in] */ wchar_t __RPC_FAR *pwchLocalName,
        /* [in] */ int cchLocalName,
        /* [in] */ wchar_t __RPC_FAR *pwchRawName,
        /* [in] */ int cchRawName,
        /* [in] */ ISAXAttributes __RPC_FAR *pAttributes);

    virtual HRESULT STDMETHODCALLTYPE endElement(
        /* [in] */ wchar_t __RPC_FAR *pwchNamespaceUri,
        /* [in] */ int cchNamespaceUri,
        /* [in] */ wchar_t __RPC_FAR *pwchLocalName,
        /* [in] */ int cchLocalName,
        /* [in] */ wchar_t __RPC_FAR *pwchRawName,
        /* [in] */ int cchRawName);

    virtual HRESULT STDMETHODCALLTYPE characters(
        /* [in] */ wchar_t __RPC_FAR *pwchChars,
        /* [in] */ int cchChars);

    virtual HRESULT STDMETHODCALLTYPE ignorableWhitespace(
        /* [in] */ wchar_t __RPC_FAR *pwchChars,
        /* [in] */ int cchChars);

    virtual HRESULT STDMETHODCALLTYPE processingInstruction(
        /* [in] */ wchar_t __RPC_FAR *pwchTarget,
        /* [in] */ int cchTarget,
        /* [in] */ wchar_t __RPC_FAR *pwchData,
        /* [in] */ int cchData);

    virtual HRESULT STDMETHODCALLTYPE skippedEntity(
        /* [in] */ wchar_t __RPC_FAR *pwchName,
        /* [in] */ int cchName);

	/*
	 * From ISAXDTDHandler
	 */

public:

	/*
	 * From ISAXEntityResolver
	 */

public:

	/*
	 * From ISAXErrorHandler
	 */

public:
    virtual HRESULT STDMETHODCALLTYPE error( 
        /* [in] */ ISAXLocator __RPC_FAR *pLocator,
        /* [in] */ unsigned short * pwchErrorMessage,
		/* [in] */ HRESULT errCode);
    
    virtual HRESULT STDMETHODCALLTYPE fatalError( 
        /* [in] */ ISAXLocator __RPC_FAR *pLocator,
        /* [in] */ unsigned short * pwchErrorMessage,
		/* [in] */ HRESULT errCode);
    
    virtual HRESULT STDMETHODCALLTYPE ignorableWarning( 
        /* [in] */ ISAXLocator __RPC_FAR *pLocator,
        /* [in] */ unsigned short * pwchErrorMessage,
		/* [in] */ HRESULT errCode);

	/*
	 * From IUnknown
	 */

public:
    long __stdcall QueryInterface(const struct _GUID &,void **);
    unsigned long __stdcall AddRef(void);
    unsigned long __stdcall Release(void);
};

#endif // !defined(AFX_DEFAULTHANDLER_H__517D91C0_0BCF_474D_A77C_10EE27231233__INCLUDED_)
