// DumpConsumer.h: interface for the CDumpConsumer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DUMPCONSUMER_H__E6B8B4E4_F98B_4E6D_BEB6_2A7946DFAAC3__INCLUDED_)
#define AFX_DUMPCONSUMER_H__E6B8B4E4_F98B_4E6D_BEB6_2A7946DFAAC3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "RDFAPI.h"

class CDumpConsumer : 
	public IRDFConsumer,
	//public IRDFSerializer,
	public ISAXErrorHandler
{
public:
	CDumpConsumer();
	virtual ~CDumpConsumer();

protected:
	INodeFactory *m_pNodeFactory;

	/*
	 * From IRDFConsumer
	 */

public:
    void startModel(void);
    void endModel(void);
    void addStatement(IStatement *pStatement);
	INodeFactory *getNodeFactory(void);

	/*
	 * From ISAXErrorHandler
	 */

public:
    virtual HRESULT STDMETHODCALLTYPE error( 
        /* [in] */ ISAXLocator __RPC_FAR *pLocator,
        /* [in] */ unsigned short * pwchErrorMessage,
		/* [in] */ HRESULT errCode);
    
    virtual HRESULT STDMETHODCALLTYPE fatalError( 
        /* [in] */ ISAXLocator __RPC_FAR *pLocator,
        /* [in] */ unsigned short * pwchErrorMessage,
		/* [in] */ HRESULT errCode);
    
    virtual HRESULT STDMETHODCALLTYPE ignorableWarning( 
        /* [in] */ ISAXLocator __RPC_FAR *pLocator,
        /* [in] */ unsigned short * pwchErrorMessage,
		/* [in] */ HRESULT errCode);

	/*
	 * From IUnknown
	 */

public:
    long __stdcall QueryInterface(const struct _GUID &,void **);
    unsigned long __stdcall AddRef(void);
    unsigned long __stdcall Release(void);
};

#endif // !defined(AFX_DUMPCONSUMER_H__E6B8B4E4_F98B_4E6D_BEB6_2A7946DFAAC3__INCLUDED_)
