// Element.cpp: implementation of the CElement class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Element.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CElement::CElement()
{
	m_pQName = NULL;
	m_pChild = NULL;
	m_pParent = NULL;
	m_nNumInParent = 0;
}

CElement::~CElement()
{
	delete m_pQName;
	delete m_pChild;
	if (m_pParent)
		m_pParent->m_pChild = NULL;
}


void CElement::putAttribute(CQName *pName, LPCTSTR pstrValue)
{
	m_Attrs.SetAt(pName->getName(), pstrValue);
}

void CElement::putAttribute(CQName *pName, wchar_t *pstrValue, int cchValue)
{
	CString sTemp = CString(pstrValue, cchValue);
	m_Attrs.SetAt(pName->getName(), sTemp);
}

CString *CElement::getAttribute(CQName *pName)
{
	CString *pString = new CString();

	m_Attrs.Lookup(pName->getName(), *pString);
	return pString;
}

void CElement::putNumInParent(int n)
{
	m_nNumInParent = n;
}

int CElement::getNumInParent(void)
{
	return m_nNumInParent;
}

CQName* CElement::getName(void)
{
	return m_pQName;
}

void CElement::putName(CQName *pName)
{
	delete m_pQName;
	m_pQName = pName;
}

void CElement::putChild(CElement* pChild)
{
	m_pChild = pChild;
}

void CElement::putParent(CElement* pParent)
{
	m_pParent = pParent;
}

CElement *CElement::getParent(void)
{
	return m_pParent;
}