// GenericParser.h: interface for the CGenericParser class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GENERICPARSER_H__4CEFAC25_3E02_432D_93D4_CBAC69B22CD4__INCLUDED_)
#define AFX_GENERICPARSER_H__4CEFAC25_3E02_432D_93D4_CBAC69B22CD4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DefaultHandler.h"
#include "Element.h"

class CGenericParser : public CDefaultHandler
{
public:
	CGenericParser();
	virtual ~CGenericParser();

	virtual CElement* createElement(void);

    HRESULT createXMLReader(
		/* [in]  */ LPCTSTR pwchClassName,
		/* [out] */ ISAXXMLReader** pRdr);

	HRESULT setErrorHandler(ISAXErrorHandler *pHandler);

protected:
	ISAXErrorHandler *m_pErrorHandler;
	int m_nNumInParent;
	CElement *m_pCurrent;
	CArray<CString, int> m_namespaces;

	/*
	 * From CDefaultHandler
	 */

public:
	virtual HRESULT STDMETHODCALLTYPE endElement(
		/* [in] */ wchar_t __RPC_FAR *pwchNamespaceUri,
		/* [in] */ int cchNamespaceUri,
		/* [in] */ wchar_t __RPC_FAR *pwchLocalName,
		/* [in] */ int cchLocalName,
		/* [in] */ wchar_t __RPC_FAR *pwchRawName,
		/* [in] */ int cchRawName);

		virtual HRESULT STDMETHODCALLTYPE startElement(
		/* [in] */ wchar_t __RPC_FAR *pwchNamespaceUri,
		/* [in] */ int cchNamespaceUri,
		/* [in] */ wchar_t __RPC_FAR *pwchLocalName,
		/* [in] */ int cchLocalName,
		/* [in] */ wchar_t __RPC_FAR *pwchRawName,
		/* [in] */ int cchRawName,
		/* [in] */ ISAXAttributes __RPC_FAR *pAttributes);

protected:
	virtual HRESULT STDMETHODCALLTYPE _endElement(
		/* [in] */ wchar_t __RPC_FAR *pwchNamespaceUri,
		/* [in] */ int cchNamespaceUri,
		/* [in] */ wchar_t __RPC_FAR *pwchLocalName,
		/* [in] */ int cchLocalName);

	virtual HRESULT STDMETHODCALLTYPE _startElement(
		/* [in] */ wchar_t __RPC_FAR *pwchNamespaceUri,
		/* [in] */ int cchNamespaceUri,
		/* [in] */ wchar_t __RPC_FAR *pwchLocalName,
		/* [in] */ int cchLocalName,
		/* [in] */ ISAXAttributes __RPC_FAR *pAttributes);
};

#endif // !defined(AFX_GENERICPARSER_H__4CEFAC25_3E02_432D_93D4_CBAC69B22CD4__INCLUDED_)
