// GenericXML2RDF.cpp: implementation of the GenericXML2RDF class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GenericXML2RDF.h"
#include "Impl.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGenericXML2RDF::CGenericXML2RDF()
{
	HRESULT hr = createXMLReader(_T("CXMLReader"), &m_pXMLReader);
	if (FAILED(hr))
		m_pXMLReader = NULL;
}

CGenericXML2RDF::~CGenericXML2RDF()
{
	if (m_pXMLReader)
		m_pXMLReader->Release();
}

ILiteral *CGenericXML2RDF::createLiteral(LPCTSTR lpstrStr)
{
	return m_pNodeFactory->createLiteral(lpstrStr);
}

IResource *CGenericXML2RDF::createResource(CQName &name)
{
	return m_pNodeFactory->createResource(name.getNamespace(), name.getLocalName());
}

IResource *CGenericXML2RDF::createResource(LPCTSTR lpstrStr)
{
	return m_pNodeFactory->createResource(lpstrStr);
}

IResource *CGenericXML2RDF::createResource(LPCTSTR pstrNamespace, LPCTSTR pstrLocalName)
{
	return m_pNodeFactory->createResource(pstrNamespace, pstrLocalName);
}

IStatement *CGenericXML2RDF::createStatement(IResource *pSubject, IResource *pPredicate, IRDFNode *pObject)
{
	return m_pNodeFactory->createStatement(pSubject, pPredicate, pObject);
}


HRESULT CGenericXML2RDF::parse(LPCTSTR pwchSource, IRDFConsumer *pConsumer)
{
	HRESULT hr = !S_OK;

	/*
	 * Set the consumer and node factory to use during processing
	 */

	m_pRDFConsumer = pConsumer;
	m_pNodeFactory = pConsumer->getNodeFactory();

	/*
	 * Initiate the parsing
	 */

	if (m_pXMLReader)
	{
		m_pXMLReader->putContentHandler(this);
		m_pXMLReader->putErrorHandler((m_pErrorHandler) ? m_pErrorHandler : this);

		int iLen = strlen(pwchSource) + 1;
		wchar_t * pURL = new wchar_t [iLen];
		mbstowcs(pURL, pwchSource, iLen);
		hr = m_pXMLReader->parseURL(pURL);
		delete [] pURL;
	}
	return hr;
}
