// GenericXML2RDF.h: interface for the CGenericXML2RDF class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GENERICXML2RDF_H__8F61C164_479D_47BF_BC1C_637EA7533BA9__INCLUDED_)
#define AFX_GENERICXML2RDF_H__8F61C164_479D_47BF_BC1C_637EA7533BA9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "RDFAPI.h"
#include "GenericParser.h"

class CGenericXML2RDF : 
	public CGenericParser, 
	public IRDFParser  
{
public:
	CGenericXML2RDF();
	virtual ~CGenericXML2RDF();

protected:
	ILiteral *createLiteral(LPCTSTR lpstrStr);
	IResource *createResource(CQName &name);
	IResource *createResource(LPCTSTR lpstrStr);
	IResource *createResource(LPCTSTR pstrNamespace, LPCTSTR pstrLocalName);
	IStatement *createStatement(IResource *pSubject, IResource *pPredicate, IRDFNode *pObject);
 
	ISAXXMLReader *m_pXMLReader;
	INodeFactory *m_pNodeFactory;
	IRDFConsumer *m_pRDFConsumer;

	/*
	 * From IRDFParser
	 */

public:
    virtual HRESULT parse(LPCTSTR pwchSource, IRDFConsumer *pConsumer);
};

#endif // !defined(AFX_GENERICXML2RDF_H__8F61C164_479D_47BF_BC1C_637EA7533BA9__INCLUDED_)
