// Impl.cpp: implementation of the CLiteral class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Impl.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLiteral::CLiteral(CString sStr)
{
	m_sContent = sStr;
}

CLiteral::~CLiteral()
{

}

CString CLiteral::getLabel(void)
{
	return m_sContent;
}


CResource::CResource()
{
	m_sNamespace = _T("");
	m_sLocalName = _T("");
}

CResource::CResource(LPCTSTR pstrNamespace, LPCTSTR pstrLocalName)
{
	m_sNamespace = pstrNamespace;
	m_sLocalName = pstrLocalName;
}

CResource::CResource(LPCTSTR pstrLocalName)
{
	m_sNamespace = _T("");
	m_sLocalName = pstrLocalName;
}

CResource::~CResource()
{

}

CString CResource::getURI(void)
{
	return m_sNamespace + m_sLocalName;
}

CString CResource::getLocalName(void)
{
	return m_sLocalName;
}

CString CResource::getNamespace(void)
{
	return m_sNamespace;
}

CString CResource::getLabel(void)
{
	return getURI();
}


CStatement::CStatement(IResource *pSubject, IResource *pPredicate, IRDFNode *pObject)
{
	m_subject = pSubject;
	m_predicate = pPredicate;
	m_object = pObject;
}

CStatement::~CStatement()
{

}

IRDFNode *CStatement::object(void)
{
	return m_object;
}

IResource *CStatement::predicate(void)
{
	return m_predicate;
}

IResource *CStatement::subject(void)
{
	return m_subject;
}

CString CStatement::getURI(void)
{
	return "";
}

CString CStatement::getLocalName(void)
{
	return getURI();
}

CString CStatement::getNamespace(void)
{
	return "";
}

CString CStatement::getLabel(void)
{
	return getURI();
}


//////////////////////////////////////////////////////////////////////
// CXMLReader Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXMLReader::CXMLReader()
{

}

CXMLReader::~CXMLReader()
{

}
