// Impl.h: interface for the CLiteral class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_IMPL_H__9363B79E_E2E1_46B2_9695_42C16C258572__INCLUDED_)
#define AFX_IMPL_H__9363B79E_E2E1_46B2_9695_42C16C258572__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "RDFAPI.h"

class CLiteral : public ILiteral
{
public:
	CLiteral(CString sStr);
	virtual ~CLiteral();

protected:
	CString m_sContent;

	/*
	 * From ILiteral
	 */

public:
	CString getLabel(void);
};


class CResource : public IResource
{
protected:
	CResource();

public:
	CResource(LPCTSTR pstrNamespace, LPCTSTR pstrLocalName);
	CResource(LPCTSTR pstrLocalName);
	virtual ~CResource();

protected:
	CString m_sNamespace;
	CString m_sLocalName;

	/*
	 * From IResource
	 */

public:
	CString getLocalName(void);
	CString getNamespace(void);
	CString getURI(void);
	CString getLabel(void);
};


class CStatement : public IStatement
{
public:
	CStatement(IResource *pSubject, IResource *pPredicate, IRDFNode *pObject);
	virtual ~CStatement();

protected:
	IResource *m_subject;
	IResource *m_predicate;
	IRDFNode *m_object;

	/*
	 * From IStatement
	 */

public:
	IResource *subject(void);
	IResource *predicate(void);
	IRDFNode *object(void);
	CString getLocalName(void);
	CString getNamespace(void);
	CString getURI(void);
	CString getLabel(void);
};


class CXMLReader : public ISAXXMLReader  
{
public:
	CXMLReader();
	virtual ~CXMLReader();

};

#endif // !defined(AFX_IMPL_H__9363B79E_E2E1_46B2_9695_42C16C258572__INCLUDED_)
