import org.w3c.dom.*;
import org.xml.sax.*;
import java.util.*;

/* represents a set of objects in the classes of a DAML/UML semantic model.
This is the set of objects represented in some XML document.
This class is a bunch of factory methods to return every object of any given class.
*/
public class XFactory
{
    Node root; // root of XML document
    MDL mdl; // internal representation of the MDL for the XML document
 
    public XFactory(Node r, MDL m)
    {
        root = r;
        mdl = m;
    }


/* return a vector of all 'course' objects represented in the document;
or null if the language does not represent objects of this class. */
public Vector every_course()
{
    int i;
    Vector res = null;
    Vector nl = mdl.getAllObjectNodes("course", root);
    if (nl != null) {
        res = new Vector();
        for (i = 0; i < nl.size(); i++)
            {res.addElement(new course((Node)nl.elementAt(i),mdl));}
    }
    return res;
}

/* return a vector of all 'person' objects represented in the document;
or null if the language does not represent objects of this class. */
public Vector every_person()
{
    int i;
    Vector res = null;
    Vector nl = mdl.getAllObjectNodes("person", root);
    if (nl != null) {
        res = new Vector();
        for (i = 0; i < nl.size(); i++)
            {res.addElement(new person((Node)nl.elementAt(i),mdl));}
    }
    return res;
}

/* return a vector of all 'teacher' objects represented in the document;
or null if the language does not represent objects of this class. */
public Vector every_teacher()
{
    int i;
    Vector res = null;
    Vector nl = mdl.getAllObjectNodes("teacher", root);
    if (nl != null) {
        res = new Vector();
        for (i = 0; i < nl.size(); i++)
            {res.addElement(new teacher((Node)nl.elementAt(i),mdl));}
    }
    return res;
}

/* return a vector of all 'student' objects represented in the document;
or null if the language does not represent objects of this class. */
public Vector every_student()
{
    int i;
    Vector res = null;
    Vector nl = mdl.getAllObjectNodes("student", root);
    if (nl != null) {
        res = new Vector();
        for (i = 0; i < nl.size(); i++)
            {res.addElement(new student((Node)nl.elementAt(i),mdl));}
    }
    return res;
}

/* return a vector of all 'result' objects represented in the document;
or null if the language does not represent objects of this class. */
public Vector every_result()
{
    int i;
    Vector res = null;
    Vector nl = mdl.getAllObjectNodes("result", root);
    if (nl != null) {
        res = new Vector();
        for (i = 0; i < nl.size(); i++)
            {res.addElement(new result((Node)nl.elementAt(i),mdl));}
    }
    return res;
}
}
