import java.util.*;

public class associationDecl
{
    private DAML daml;
    public String class1Name,class2Name;
    public boolean class1Unique,class2Unique;
    public String associationName; 
    public String comment;
        
    public associationDecl(String c1Name, String aName, String c2Name, boolean c1u, boolean c2u, DAML d)
    {
        class1Name = c1Name;
        class2Name = c2Name;
        class1Unique = c1u;
        class2Unique = c2u;
        associationName = aName;
        comment = null;
        daml = d;
    }
    
    /* check that both owning classes exist, and if so add this
    association to both their vectors of associations */
    public boolean addToClasses()
    {
        boolean res = true;
        classDecl cd1,cd2;

        cd1 = daml.getClass(class1Name);
        if (cd1 == null)
        {
            res = false;
            daml.message("No class " + class1Name + " to own association " + associationName);
        }

        cd2 = daml.getClass(class2Name);
        if (cd2 == null)
        {
            res = false;
            daml.message("No class " + class2Name + " to own association " + associationName);
        }

        if (res) 
        {
            cd1.addLeftAssociation(this);
            cd2.addRightAssociation(this);
        }
        return res;
    }
    
    /* vector of all associationDecl objects, where the left hand
     class is replaced by one of its descendant classes or itself.*/
    public Vector leftDescendantAssociations()
    {
        int i;
        classDecl desc;
        Vector res = new Vector();
        Vector dc = daml.getClass(class1Name).subClasses();
        for (i = 0; i < dc.size(); i++)
        {
            desc = (classDecl)dc.elementAt(i);
            res.addElement(new associationDecl(desc.className, associationName,class2Name,class1Unique,class2Unique,daml));
        }
        return res;
    }
    
    /* vector of all associationDecl objects, where the right hand
     class is replaced by one of its descendant classes or itself.*/
    public Vector rightDescendantAssociations()
    {
        int i;
        classDecl desc;
        Vector res = new Vector();
        Vector dc = daml.getClass(class2Name).subClasses();
        for (i = 0; i < dc.size(); i++)
        {
            desc = (classDecl)dc.elementAt(i);
            res.addElement(new associationDecl(class1Name, associationName,desc.className,class1Unique,class2Unique,daml));
        }
        return res;
    }
}