import org.w3c.dom.*;
import org.xml.sax.*;
import java.util.*;

/* represents a set of objects in the classes of a DAML/UML semantic model.
This is the set of objects represented in some XML document.
This class is a bunch of factory methods to return every object of any given class.
*/
public class XFactory
{
    Node root; // root of XML document
    MDL mdl; // internal representation of the MDL for the XML document
 
    public XFactory(Node r, MDL m)
    {
        root = r;
        mdl = m;
    }


/* return a vector of all 'purchaseOrder' objects represented in the document;
or null if the language does not represent objects of this class. */
public Vector every_purchaseOrder()
{
    int i;
    Vector res = null;
    Vector nl = mdl.getAllObjectNodes("purchaseOrder", root);
    if (nl != null) {
        res = new Vector();
        for (i = 0; i < nl.size(); i++)
            {res.addElement(new purchaseOrder((Node)nl.elementAt(i),mdl));}
    }
    return res;
}

/* return a vector of all 'purchOrdLine' objects represented in the document;
or null if the language does not represent objects of this class. */
public Vector every_purchOrdLine()
{
    int i;
    Vector res = null;
    Vector nl = mdl.getAllObjectNodes("purchOrdLine", root);
    if (nl != null) {
        res = new Vector();
        for (i = 0; i < nl.size(); i++)
            {res.addElement(new purchOrdLine((Node)nl.elementAt(i),mdl));}
    }
    return res;
}

/* return a vector of all 'product' objects represented in the document;
or null if the language does not represent objects of this class. */
public Vector every_product()
{
    int i;
    Vector res = null;
    Vector nl = mdl.getAllObjectNodes("product", root);
    if (nl != null) {
        res = new Vector();
        for (i = 0; i < nl.size(); i++)
            {res.addElement(new product((Node)nl.elementAt(i),mdl));}
    }
    return res;
}

/* return a vector of all 'purchasingUnit' objects represented in the document;
or null if the language does not represent objects of this class. */
public Vector every_purchasingUnit()
{
    int i;
    Vector res = null;
    Vector nl = mdl.getAllObjectNodes("purchasingUnit", root);
    if (nl != null) {
        res = new Vector();
        for (i = 0; i < nl.size(); i++)
            {res.addElement(new purchasingUnit((Node)nl.elementAt(i),mdl));}
    }
    return res;
}

/* return a vector of all 'shippingAddress' objects represented in the document;
or null if the language does not represent objects of this class. */
public Vector every_shippingAddress()
{
    int i;
    Vector res = null;
    Vector nl = mdl.getAllObjectNodes("shippingAddress", root);
    if (nl != null) {
        res = new Vector();
        for (i = 0; i < nl.size(); i++)
            {res.addElement(new shippingAddress((Node)nl.elementAt(i),mdl));}
    }
    return res;
}

/* return a vector of all 'manufacturer' objects represented in the document;
or null if the language does not represent objects of this class. */
public Vector every_manufacturer()
{
    int i;
    Vector res = null;
    Vector nl = mdl.getAllObjectNodes("manufacturer", root);
    if (nl != null) {
        res = new Vector();
        for (i = 0; i < nl.size(); i++)
            {res.addElement(new manufacturer((Node)nl.elementAt(i),mdl));}
    }
    return res;
}

/* return a vector of all 'recipientUnit' objects represented in the document;
or null if the language does not represent objects of this class. */
public Vector every_recipientUnit()
{
    int i;
    Vector res = null;
    Vector nl = mdl.getAllObjectNodes("recipientUnit", root);
    if (nl != null) {
        res = new Vector();
        for (i = 0; i < nl.size(); i++)
            {res.addElement(new recipientUnit((Node)nl.elementAt(i),mdl));}
    }
    return res;
}
}
